var selectRowsJs = {

	// return the version if this selectRowsJs library.
    version: function() {
        return '1.0.1';
    },

	// get the value of data-input-id from_row the checkbox with class 'select-all-rows' and data-rows-group-id equal to the parameter group_id.
	// uncheck all the checkboxes with class 'select-row' and data-rows-group-id equal to the parameter group_id.
	// check all the checkboxes with class 'select-row' and data-rows-group-id equal to the parameter group_id, and data-id included in the value of the input with class 'select-all-rows' and data-input-id equal to the parameter input_id.
	initialize_checkboxes: function(group_id) {
		var input_id = $('.select-all-rows[data-rows-group-id="' + group_id + '"]').data('input-id');
		var input_value = $('#' + input_id).val();
		var input_value_array = input_value.split(',');
		$('.select-row[data-rows-group-id="' + group_id + '"]').prop('checked', false);
		$('.select-row[data-rows-group-id="' + group_id + '"]').each(function() {
			var id = $(this).data('id');
			if (input_value_array.indexOf(id) != -1) {
				$(this).prop('checked', true);
			}
		});
	},

	// enable all the buttons with the same data-rows-group-id if there is one or more checked checkboxes with class 'select-row' and data-rows-group-id equal to the parameter group_id.
	// disable all the buttons with the same data-rows-group-id if there is no checked checkboxes with class 'select-row' and data-rows-group-id equal to the parameter group_id.
	enable_disable_buttons: function(group_id) {
		var checked_count = $("input.select-row[data-rows-group-id='" + group_id + "']:checked").length;
		if (checked_count > 0) {
			$("button[data-rows-group-id='" + group_id + "']").removeAttr('disabled');
		} else {
			$("button[data-rows-group-id='" + group_id + "']").attr('disabled', 'disabled');
		}
	},

	// get the value of data-input-id from_row the checkbox with class 'select-all-rows' and data-rows-group-id equal to the parameter group_id.
	// update the input box .ids with the data-id of all the selected .select-row with data-rows-group-id equal to the parameter group_id.
	update_input_ids: function(group_id) {
		var input_id = $('input.select-all-rows[data-rows-group-id="'+group_id+'"]').data('input-id');
		var ids = [];
		$('input.select-row[data-rows-group-id="'+group_id+'"]:checked').each(function() {
			ids.push($(this).data('id'));
		});
		$('input#'+input_id).val(ids.join(','));
	},
	

	// store the original function to call it later.
	// for each group of checkboxes, call to the function initialize_checkboxes when the page is loaded.
	// then, call the old code of the $(document).ready. 
    init: function() {
        let old_onload = window.onload;

		// when check .select-all-rows is checked, check all checkboxes .select-row with the same data-rows-group-id attribute.
		// when check .select-all-rows is unchecked, uncheck all checkboxes .select-row with the same data-rows-group-id attribute.
		// call the function update_input_ids with the data-rows-group-id attribute of the checkbox .select-all-rows.
		// call the function enable_disable_buttons with the data-rows-group-id attribute of the checkbox .select-all-rows.
		$('.select-all-rows').click(function() {
			var group_id = $(this).data('rows-group-id');
			if ($(this).is(':checked')) {
				$('input.select-row[data-rows-group-id="'+group_id+'"]').prop('checked', true);
			} else {
				$('input.select-row[data-rows-group-id="'+group_id+'"]').prop('checked', false);
			}
			selectRowsJs.update_input_ids(group_id);
			selectRowsJs.enable_disable_buttons(group_id);
		});
	
		// when check .select-row is checked, update the input box .ids with the data-id of all the selected .select-row with the same data-rows-group-id.
		// when check .select-row is unchecked, update the input box .ids with the data-id of all the selected .select-row with the same data-rows-group-id.
		// call the function enable_disable_buttons with the data-rows-group-id attribute of the checkbox .select-row.
		$('.select-row').click(function() {
			var group_id = $(this).data('rows-group-id');
			selectRowsJs.update_input_ids(group_id);
			selectRowsJs.enable_disable_buttons(group_id);
		});

		// call the function initialize_checkboxes with the data-rows-group-id attribute of the checkbox .select-all-rows.
		// then, call the old code of the window.onload.
        window.onload = function () {
			$('.select-all-rows').each(function() {
				var group_id = $(this).data('rows-group-id');
				selectRowsJs.initialize_checkboxes(group_id);
				selectRowsJs.enable_disable_buttons(group_id);
			});

            // call the original onload function
            if (typeof old_onload == 'function') {
                old_onload();
            }
        }
    },
} // var selectRowsJs